#!/bin/bash

#Copyright (C) 2018 Raryel C. Souza <raryel.costa at gmail.com>

#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <https://www.gnu.org/licenses/>.

#dislocker-gui-zenity
#This util-root.sh script contains the commands used by the dislocker-gui.sh
#that need to be run as root user

DFILE_LOCATION="/tmp/DFILE"

ACTION=$1
case $ACTION in
  "clearTMP")
      rm -f /tmp/fdisk.txt
      rm -f /tmp/drive_selection_list.txt
      ;;

  "checkBitLockerDriveMounted")
      DRIVE_MOUNTPOINT=$2
      echo $(mount | grep -q "$DRIVE_MOUNTPOINT\|$DFILE_LOCATION"; echo $?)
      ;;

  "isBitlockerDrive")
      DRIVE=$2
      echo $(dislocker-fuse -r -V "/dev/$DRIVE" | grep -q "None of the provided decryption mean is decrypting the keys."; echo $?)
      ;;

  "createMountDir")
      DRIVE_MOUNTPOINT=$2
      mkdir -p $DRIVE_MOUNTPOINT
      mkdir -p $DFILE_LOCATION
      ;;

  "decrypt")
      DRIVE_SELECTED=$2
      DRIVE_PASSWORD=$3
      DRIVE_UID=$4
      DRIVE_GID=$5
      #if the output contains the string "Can't decrypt correctly the VMK." it means the password supplied is wrong
       echo $(dislocker-fuse -v -V /dev/"$DRIVE_SELECTED" -u$DRIVE_PASSWORD -- $DFILE_LOCATION -o uid=$DRIVE_UID,gid=$DRIVE_GID  | grep -q "Can't decrypt correctly the VMK."; echo $?)
      ;;

  "mount")
      DRIVE_MOUNTPOINT=$2
      DRIVE_UID=$3
      DRIVE_GID=$4
      if [ -f $DFILE_LOCATION/dislocker-file ];
      then
          mount -o loop,rw,uid=$DRIVE_UID,gid=$DRIVE_GID $DFILE_LOCATION/dislocker-file $DRIVE_MOUNTPOINT
      else
       zenity --error --title="Error" --no-wrap --text="bitLock mount error"
      umount $DRIVE_MOUNTPOINT 2>/dev/null
      umount $DFILE_LOCATION   2>/dev/null
      exit 1
      fi
      ;;

  "umount")
      DRIVE_MOUNTPOINT=$2
      umount $DRIVE_MOUNTPOINT
      umount $DFILE_LOCATION
      ;;

  "getListNTFSDrives")
      #get list of NTFS/exFAT/HPFS drives and saves the list to the temp file
#      fdisk -l | grep NTFS | cut -c6-9 > /tmp/fdisk.txt
	lsblk -l -n > /tmp/fdisk.txt
    ;;
esac
